{************************************************}
{                                                }
{   ObjectWindows Demo                           }
{   Copyright (c) 1992 by Borland International  }
{                                                }
{************************************************}
{   Modified Prntest as follows:                 }
{       8/21/93                                  }
{          fixed scrolling for larger files      }
{          added largecol unit (breaks 16380 lim)}
{          added commdlg for fonts               }
{          added a status bar for info           }
{       9/4/93                                   }
{          added search function                 }
{          added printer margin/headers          }
{          added ctl3d for dialogs               }
{       9/11/93                                  }
{          added dragdrop                        }
{          added "constant headings" for col rpts}
{          added icon and about box              }
{                                                }
{   Peter Franchuk, Rochester NY                 }
{     [76476,1414] or [74146,225]                }
{************************************************}

program prntvwr;

uses WinDos, Strings, WinTypes, WinProcs, Objects, OWindows, Win31,
 ODialogs, OPrinter, commdlg, Ctl3D, ribstat, largecol, ShellApi;

{$R PRNTVWR.RES}
const
  wm_UpDateStatus = wm_User + 20;

{$I PRNTVWR.INC}

{$DEFINE ConstantHdr}


type
  TFilename = array[0..fsPathName] of Char;

  PPCharCollection = ^TPCharCollection;
  TPCharCollection = object(TLCollection)
    procedure FreeItem(Item: Pointer); virtual;
  end;

  TTextApp = object(T3dApplication)
    procedure InitMainWindow; virtual;
    procedure InitInstance; virtual;
  end;

  PTextWindow = ^TTextWindow;
  TTextWindow = object(T3dWindow)
    LPixY:word;
    constructor Init(AParent: PWindowsObject);
    procedure SetupWindow; virtual;
    procedure AdjustSize(width,height:word);
    procedure Paint(PaintDC: HDC; var PaintInfo: TPaintStruct); virtual;
  end;

  PTextPrint = ^TTextPrint;
  TTextPrint = object(TPrintout)
    TextHeight, LinesPerPage, FirstOnPage, LastOnPage, Attop: Integer;
    PrFont: TLogfont;PHFont,oldFont:hFOnt;
    hlne:array[1..6] of array[0..20] of char;
    xOffset,hdry,lney,ftry,pageplace:word;hdrexists,ftrexists:boolean;
    constructor Init(ATitle: PChar);
    destructor Done; virtual;
    function GetDialogInfo(var Pages: Integer): Boolean; virtual;
    function HasNextPage(Page: Word): Boolean; virtual;
    procedure SetPrintParams(ADC: HDC; ASize: TPoint); virtual;
    procedure PrintPage(Page: Word; var Rect: TRect; Flags: Word); virtual;
    procedure GetUserParams(ADC: HDC);
  end;

  PTheMain = ^TTheMain;
  TTheMain = object(T3dWIndow)
    searchdir,senscase:boolean;
    searchStr:array[0..90] of char;
    Printer: PPrinter;
    PRibbon:PBotLnebar;
    pViewer:pTextWindow;
    constructor Init(AParent: PWindowsObject; ATitle: PChar);
    function GetClassName:PChar;virtual;
    procedure GetWindowClass(var AWndClass: TWndClass);virtual;
    destructor Done; virtual;
    procedure CMFileOpen(var Msg: TMessage); virtual cm_First + cm_FileOpen;
    procedure CMFilePrint(var Msg: TMessage); virtual cm_First + cm_FilePrint;
    procedure CMPrntSet(var Msg:TMessage); virtual cm_First + cm_PrntSet;
    procedure CMFind(var Msg:Tmessage); virtual cm_First + cm_Find;
    procedure CMNext(var Msg:Tmessage); virtual cm_First + cm_Next;
    procedure CMAbout(var Msg:Tmessage); virtual cm_First + cm_About;
    procedure WMSize(var Msg:TMessage); virtual wm_First + wm_Size;
    procedure WMUpDate(var Msg:TMessage); virtual wm_First + wm_UpDateStatus;
    procedure WMDropfiles(var msg:Tmessage); virtual wm_First + wm_Dropfiles;
    procedure CMEnlarge(var Msg:TMessage); virtual cm_First + cm_Enlarge;
    procedure CMReduce(var Msg:TMessage); virtual cm_First + cm_Reduce;
    procedure CMFonts(var msg:Tmessage); virtual cm_First + cm_Fonts;
    procedure LoadFile;
  end;

VAR
  FileName,FileTitle: TFilename;
  FileLines: PPCharCollection;
  LFont: TLogfont;
  DptSize:integer;
  MaxLineLength:word;




procedure TPCharCollection.FreeItem(Item: Pointer);
begin
  StrDispose(PChar(Item));
end;

constructor TTheMain.Init(AParent: PWindowsObject; ATitle: PChar);
begin
  inherited Init(AParent, ATitle);
  Attr.Menu := LoadMenu(HInstance, 'MAINMENU');
  attr.Exstyle := attr.Exstyle or ws_ex_Acceptfiles;
  pRibbon := new(Pbotlnebar, init(@self));
  Printer := New(PPrinter, Init);
  pviewer :=new(PTextWindow,init(@self));
  FileLines := nil;
  strcopy(searchStr,'');
  searchdir := true;
  senscase := true;
  DptSize := 100;
  fillchar(LFont,sizeof(TLogFont),#0);
  with LFont do
   begin
    lfHeight := -13;
    lfWeight := 400;
    lfOutPrecision := 3;
    lfClipPrecision := 2;
    lfQuality := 1;
    lfPitchAndFamily := 49;
    strcopy(lfFaceName,'Courier New');
   end;
end;


  function TTheMain.GetClassName:PChar;
  begin
   GetClassName := 'TFileView';
  end;

  procedure TTheMain.GetWindowClass(var AWndClass: TWndClass);
  begin
   inherited GetWindowClass(AWndClass);
   AWndClass.hIcon := LoadIcon(HInstance, PChar(100));
  end;

destructor TTheMain.Done;
begin
  if Assigned(FileLines) then Dispose(FileLines, Done);
  inherited Done;
end;

procedure TTheMain.wmSize(var Msg: TMessage);
begin
 inherited wmsize(msg);
 pRibbon^.adjustsize(msg.LParamLo,msg.LParamHi);
 pViewer^.adjustsize(msg.LParamLo,msg.LParamHi);
end;


procedure TTheMain.WMDropfiles(var msg:TMessage);
  var
   wsize,i:integer;
   Fleinfo:Tofstruct;
   Flist:Thandle;
  begin
    Flist := msg.wParam;
    wSize := DragQueryFile(Flist,0,nil,0) +1;
    DragQueryFile(Flist,0,FileName,wSize);
    DragFinish(Flist);
    if isIconic(hWindow) then show(sw_ShowNormal);
    LoadFile;
  end;

procedure TTheMain.CMFileOpen(var Msg: TMessage);
var
  OpenFN      : TOpenFileName;
  Filter      : array [0..100] of Char;
begin
  StrCopy(FileName, '');
  FillChar(Filter, SizeOf(Filter), #0);
  strPcopy(@Filter,'Text(*.txt)'+#0+'*.txt'+#0+'Printout(*.prn)'+#0
    +'*.prn'+#0+'Listing(*.lst)'+#0+'*.lst'+#0+'All files(*.*)'+#0+'*.*');

  FillChar(OpenFN, SizeOf(TOpenFileName), #0);
  with OpenFN do
  begin
    hInstance     := HInstance;
    hwndOwner     := HWindow;
    lpstrDefExt   := 'txt';
    lpstrFile     := FileName;
    lpstrFilter   := Filter;
    lpstrFileTitle:= FileTitle;
    flags         := ofn_FileMustExist or ofn_HideReadOnly;
    lStructSize   := sizeof(TOpenFileName);
    nFilterIndex  := 1;
    nMaxFile      := SizeOf(FileName);
  end;
  if  GetOpenFileName(OpenFN) then LoadFile;
end;

procedure TTheMain.CMFilePrint(var Msg: TMessage);
var
  Printout: PPrintout;
begin
  if not assigned(FileLines) then exit;
  Printout := New(PTextPrint, Init(FileName));
  Printer^.Print(@Self, Printout);
  Dispose(Printout, Done);
end;

procedure TTheMain.CMPrntSet(var Msg: TMessage);
begin
  Printer^.Setup(@self);
end;

 procedure TTheMain.CMAbout(var msg:Tmessage);
  var
   Dialog: TDialog;
  begin
   Dialog.Init(@self,'About');
   Dialog.Execute;
   Dialog.Done;
  end;

procedure TTheMain.CMFind(var Msg:Tmessage);
var
  d:Pdialog;
  e:Pedit;
  b:PRadiobutton;
  c:PCheckbox;
  retcde:integer;
  getinfo:Record
   TheString:array[0..90] of char;
   Fwdir,rvdir,csens:word;
  end;
begin
  if not assigned(FileLines) then exit;
  d := new(Pdialog,init(@self,'find'));
  new(e,Initresource(d,id_string,sizeof(getinfo.TheString)));
  new(b,Initresource(d,id_forward));
  new(b,Initresource(d,id_reverse));
  new(c,Initresource(d,id_case));
  with GetInfo do
   begin
    strcopy(TheString,SearchStr);
    if searchdir
     then begin Fwdir :=1;rvdir :=0 end
     else begin Fwdir :=0;rvdir :=1 end;
    if senscase then csens := 1 else csens :=0;
   end;
  d^.transferbuffer := @getinfo;
  retcde := application^.execdialog(d);
  if retcde<>IDOK then exit;
  with getinfo do
   begin
    strcopy(SearchStr,@TheString);
    searchdir := fwdir=bf_Checked;
    senscase := csens=bf_Checked;
   end;
  if strlen(SearchStr)=0 then exit;
  CMNext(msg);
end;

procedure TTheMain.CMNext(var Msg:TMessage);
var
  index:longint;
  i:integer;
  TestString:string[255];
  Teststr:PChar;
  found:boolean;
  SrchString:string[25];
begin
 if not assigned(FileLines) then exit;
 if strlen(SearchStr)=0 then exit;
 index := pviewer^.Scroller^.YPos;
 SrchString := StrPas(SearchStr);
 if not senscase then
  for i := 1 to length(SrchString)
   do SrchString[i] :=UpCase(SrchString[i]);
 if searchdir then
   while index<FileLines^.count-1 do
    begin
     inc(index);Teststr :=pchar(FileLines^.at(index));
     if Teststr<>nil then
      begin
       TestString := StrPas(Teststr);
       if not senscase then
        for i := 1 to length(TestString)
         do TestString[i] := Upcase(TestString[i]);
       found :=  pos(SrchString,TestString)<>0;
       if found then break;
      end;
    end
  else
   while index>0 do
    begin
     dec(index);Teststr :=pchar(FileLines^.at(index));
     if Teststr<>nil then
      begin
       TestString := StrPas(Teststr);
       if not senscase then
        for i := 1 to length(TestString)
         do TestString[i] := Upcase(TestString[i]);
       found :=  pos(SrchString,TestString)<>0;
       if found then break;
      end
    end;
 if found
  then begin
   pviewer^.Scroller^.YPos := index;
   InvalidateRect(hWindow,nil,true);
  end else messagebox(hWindow,SearchStr,'Not Found',mb_ok or mb_iconasterisk);
end;

procedure TTheMain.WMUpDate(var msg:TMessage);
var TheTitle:array[0..120] of char;Lnum:array[0.. 10] of char;
begin
 strcopy(TheTitle,FileName);
 strcat(TheTitle,' at: ');
 str(msg.wParam:4,Lnum);
 pRibbon^.SetDisplayLine(strcat(TheTitle,lnum));
end;

procedure TTheMain.CMEnlarge(var MSg:TMessage);
begin
 if DptSize<120 then inc(DptSize,10) else inc(DptSize,20);
 if DptSize>240 then DptSize := 240;
 LFont.lfHeight := -1 * MulDiv(pviewer^.LpixY,DptSize,720);
 InvalidateRect(hwindow,nil,true);
end;

procedure TTheMain.CMReduce(var Msg:TMessage);
begin
 if DptSize<= 120 then dec(DptSize,10) else dec(DptSize,20);
 if DptSize<40 then DptSize := 40;
 LFont.lfHeight := -1 * MulDiv(pviewer^.LpixY,DptSize,720);
 InvalidateRect(hwindow,nil,true);
end;

procedure TTheMain.CMFonts(var Msg: TMessage);
var
  ChooseRec: TChooseFont;
begin
  FillChar(ChooseRec, SizeOf(ChooseRec), #0);
  with ChooseRec do
  begin
    lStructSize:= SizeOf(TChooseFont);
    hwndOwner  := HWindow;
    hDC        := Printer^.GetDC;
    lpLogFont  := @LFont;
    Flags      := cf_Both or cf_ScalableOnly or cf_InitToLogFontStruct or cf_LimitSize;
    nSizeMin   := 4;
    nSizeMax   := 24;
  end;
  if not ChooseFont(ChooseRec) then
    Exit;
  DptSize := ChooseRec.iPointSize;
  InvalidateRect(HWindow, nil, True);
end;

procedure TTheMain.LoadFile;
var
  TextLine: array[0..255] of Char;
  TextFile: Text;
  Forsize:file;
  R:TRect;
  cnt:longint;
begin
  if Assigned(FileLines) then
   begin Dispose(FileLines, Done);FileLines := nil end;
  MaxLineLength := 0;
  cnt := 0;
  Assign(TextFile, FileName);
  Reset(TextFile);
  pRibbon^.DisplayString(0);
  { We will use the first 10 non-empty lines to estimate a size }
  {    for our collection                                       }
  while (cnt<10) and (not eof(TextFile)) do
   begin
    Readln(TextFile,Textline);
    if strlen(Textline)>0 then
     begin inc(cnt);inc(MaxLineLength,strlen(TextLine)); end;
   end;
  if cnt>0
   then MaxLineLength := MaxLineLength div cnt
   else MaxLineLength := 10;
  close(TextFile);
  Assign(Forsize,FileName);
  Reset(Forsize,1);
  cnt := FileSize(ForSize) div MaxLineLength;
  close(ForSize);
  { If we are using TCollection, we will make sure we can hold the file
  if cnt>MaxCollectionSize
   then begin
    messagebox(hWindow,FileName,'File too large!',mb_ok);
    FileName[0] := #0;
    InvalidateRect(hWIndow,nil,true);
    exit
   end;      }
  FileLines := New(PPCharCollection, Init(cnt, 100));
  Assign(TextFile, FileName);
  Reset(TextFile);
  while not eof(TextFile) do
  begin
    Readln(TextFile, TextLine);
    FileLines^.Insert(StrNew(TextLine));
    if strlen(TextLine)>MaxLineLength then MaxLineLength := strlen(TextLine);
  end;
  Close(TextFile);
  Pviewer^.Scroller^.SetRange(MaxLineLength-2,FileLines^.count-1);
  Pviewer^.Scroller^.YPos :=0;
  InvalidateRect(hWindow,nil,true);
end;

constructor TTextWindow.Init(AParent: PWindowsObject);
begin
  inherited Init(AParent,nil);
  Attr.Style := ws_child or ws_border or ws_visible or ws_VScroll or ws_HScroll;
  Scroller := New(PScroller, Init(@Self, 10, 17, 80,30));
  Scroller^.AutoOrg := false;
end;

procedure TTextWindow.SetUpWindow;
var mydc:hDC;R:Trect;
begin
 inherited SetupWindow;
 mydc := GetDC(hwindow);
 LPixY := GetDeviceCaps(mydc,LOGPIXELSY);
 ReleaseDC(Hwindow,mydc);
end;

procedure TTextWindow.AdjustSize(width,height:word);
begin
 movewindow(hWindow,0,0,width,height,true);
end;

procedure TTextWindow.Paint(PaintDC: HDC; var PaintInfo: TPaintStruct);
var
  Line: longint;
  OutLine,stop,x: Integer;
  TextMetrics: TTextMetric;
  TheText: PChar;
  TheTitle:array [0..120] of char;
  TheTop:array[0..8] of char;
  TheFont,oldFont:hFont;
begin
  if not assigned(FileLines) then exit;
  TheFont:=CreateFontindirect(LFont);
  oldFont := SelectObject(PaintDC,TheFont);
  GetTextMetrics(PaintDC, TextMetrics);
  Line := Scroller^.Ypos;
  x := TextMetrics.tmAveCharWidth;
  Scroller^.SetUnits(x, TextMetrics.tmHeight+TextMetrics.tmExternalLeading);
  Scroller^.SetPageSize;
  outLine := { 0 } PaintInfo.rcPaint.top div Scroller^.YUnit;
  Line := Scroller^.Ypos + outline;
  Stop := {Scroller^.YPage+1} PaintInfo.rcPaint.bottom div Scroller^.YUnit;
  while (Line < FileLines^.Count) and (OutLine<=stop)  do
  begin
     TheText := PChar(FileLines^.At(Line));
    if TheText <> nil then
      TextOut(PaintDC, x*(1-Scroller^.XPos), OutLine * Scroller^.YUnit, TheText, StrLen(TheText));
   Inc(Line);inc(outline);
  end;
  SelectObject(PaintDC,oldFont);
  DeleteObject(TheFont);
  sendmessage(parent^.hWindow,wm_UpDateStatus,Scroller^.YPos+1,0)
end;

procedure TTextApp.InitMainWindow;
begin
  MainWindow := New(PTheMain, Init(nil, 'Text Viewer'));
  HAccTable := LoadAccelerators(HInstance, MakeIntResource(100));
end;

procedure TTextApp.InitInstance;
begin
  inherited InitInstance;
  Register3DApp(Application^.name,true,true,true);
end;

constructor TTextPrint.Init(ATitle: PChar);
begin
  inherited Init(ATitle);
  FirstOnPage := 0;
  LastOnPage := 0;
  xOffset := 0;
end;

destructor TTextPrint.done;
begin
 deleteobject(phfont);
 inherited done;
end;

function TTextPrint.GetDialogInfo(var Pages: Integer): Boolean;
begin
  Pages := FileLines^.Count div LinesPerPage + 1;
  GetDialogInfo := True;
end;

function TTextPrint.HasNextPage(Page: Word): Boolean;
begin
  HasNextPage := LastOnPage < FileLines^.Count - 1;
end;

procedure TTextPrint.SetPrintParams(ADC: HDC; ASize: TPoint);
var
  TextMetrics: TTextMetric;
begin
  inherited SetPrintParams(ADC, ASize);
  GetUserParams(ADC);
  GetTextMetrics(ADC, TextMetrics);
  TextHeight := TextMetrics.tmHeight + TextMetrics.tmExternalLeading;
  LinesPerPage := (Size.Y-(hdry+ftry)) div TextHeight;
  ftry := Size.Y-ftry;
  if hdrexists then
   begin
    lney := hdry+2*TextHeight;dec(LinesPerPage,2);
    if attop>0 then
     begin lney := lney+(attop-1)*TextHeight; dec(LinesPerPage,attop-1); end;
   end
   else lney := hdry;
  if ftrexists then
   begin
    dec(LinesPerPage,2);dec(ftry,TextHeight); end;
  if (TextMetrics.tmAveCharWidth*MaxLineLength>(Size.x-xOffset))
   then messagebox(application^.mainwindow^.hwindow,'Some lines may be truncated','Warning!',
          mb_ok or mb_IconExclamation);
  selectObject(ADC,oldFont);
end;

procedure TTextPrint.GetUserParams(ADC:HDC);
var
 Trec:record
  hdlf,hdct,hdrt:array[0..20] of char;
  ftlf,ftct,ftrt:array[0..20] of char;
  stop,slft,sbot:array[0..8] of char;
{$IFDEF ConstantHdr}
  hdlines:array[0..3] of char;
{$ENDIF}
 end;
 tmar,lmar,bmar,treal:real;
 d:PDialog;
 e:pedit;
 i,y,m,dy,dow,LpixY:word;
 temp:array[0..4]of char;
 ierr : integer;
begin
 PrFont := LFont;
 LpixY := GetDeviceCaps(ADC,LogPixelsY);
 PrFont.lfHeight := -1 * MulDiv(LpixY,DptSize,720);
 phfont := CreateFontIndirect(prFont);
 oldFont := selectobject(ADC,phfont);
{$IFDEF ConstantHdr}
 d := new(Pdialog,init(application^.MainWindow,'PAGELKA'));
{$ELSE}
 d := new(Pdialog,init(application^.MainWindow,'PAGELK'));
{$ENDIF}
 for i := id_phlft to id_pfrgt do
  new(e,initresource(d,i,sizeof(Trec.hdlf)));
 for i := id_tmar to id_bmar do
  new(e,initresource(d,i,sizeof(Trec.stop)));
{$IFDEF ConstantHdr}
 new(e,initresource(d,id_nlines,sizeof(Trec.hdlines)));
{$ENDIF}
 GetDate(y,m,dy,dow);
 with Trec do
  begin
   hdlf[0]:=#0; strcopy(hdct,FileTitle);

   str(m,temp);
   if strlen(temp)<2 then strcopy(hdrt,'0') else strcopy(hdrt,'');
   strcat(hdrt,temp);strcat(hdrt,'/');
   str(dy,temp);
   if strlen(temp)<2 then strcat(hdrt,'0');
   strcat(hdrt,temp);strcat(hdrt,'/');
   str((y mod 100),temp);
   if strlen(temp)<2 then strcat(hdrt,'0');
   strcat(hdrt,temp);

   ftlf[0]:=#0; strcopy(ftct,'Page #'); ftrt[0]:=#0;

   strcopy(stop,'0.0');
   strcopy(slft,'0.25');
   strcopy(sbot,'0.0');
{$IFDEF ConstantHdr}
   hdlines[0] := #0;
{$ENDIF}
  end;
 d^.transferbuffer := @Trec;
 application^.execDialog(d);
 with Trec do
  begin
   strcopy(hlne[1],hdlf);strcopy(hlne[2],hdct);strcopy(hlne[3],hdrt);
   strcopy(hlne[4],ftlf);strcopy(hlne[5],ftct);strcopy(hlne[6],ftrt);
   val(stop,tmar,ierr);val(slft,lmar,ierr);val(sbot,bmar,ierr);
   attop := 0;
{$IFDEF ConstantHdr}
   if strlen(hdlines)>0 then val(hdlines,attop,ierr);
{$ENDIF}
  end;
 xOffset := trunc(GetDevicecaps(ADC,LogPixelsX)*lmar);
 hdry := trunc(LpixY*tmar);
 ftry := trunc(LpixY*bmar);
 hdrexists := strlen(hlne[1])+strlen(hlne[2])+strlen(hlne[3]){+attop}>0;
 ftrexists := strlen(hlne[4])+strlen(hlne[5])+strlen(hlne[6])>0;
 pageplace := 0;
 if attop>0 then for i := 1 to 3 do hlne[i][0] := #0;
 for i := 1 to 6 do
  if (strlen(hlne[i])<>0) and (pos('Page #',StrPas(hlne[i]))<>0)
   then pageplace := i;
end;

procedure TTextPrint.PrintPage(Page: Word; var Rect: TRect; Flags: Word);
var
  Line: longint;
  TheText: PChar;
  tmp:array[0..8] of char;
  oFont:hFont;
  tmpy:integer;
begin
  oFont := SelectObject(DC,phfont);
  FirstOnPage := (Page - 1) * LinesPerPage + attop;
  LastOnPage := (Page * LinesPerPage) - 1 + attop;
  if LastOnPage >= FileLines^.Count then LastOnPage := FileLines^.Count - 1;
  if pageplace>0 then
   begin
    str(Page,tmp);
    strcopy(hlne[pageplace],'Page ');
    strcat(hlne[pageplace],tmp);
   end;
  if (attop>0) then
   for line := 0 to attop-1 do
    begin
    TheText := FileLines^.At(Line);
    if TheText <> nil then
      TextOut(DC,xOffset,hdry+Line*TextHeight,TheText,StrLen(TheText));
    end;
  if hdrexists and (attop=0) then
   begin
    if strlen(hlne[1])>0 then TextOut(DC,xOffset,hdry,hlne[1],strlen(hlne[1]));
    if strlen(hlne[2])>0 then
     begin
      SetTextAlign(DC,TA_Center or TA_Top);
      TextOut(DC,(size.x-xOffset) div 2,hdry,hlne[2],strlen(hlne[2]));
     end;
    if strlen(hlne[3])>0 then
     begin
      SetTextAlign(DC,TA_Right or TA_Top);
      TextOut(DC,size.x,hdry,hlne[3],strlen(hlne[3]));
     end;
    SetTextAlign(DC,TA_Left or TA_Top);
   end;
  for Line := FirstOnPage to LastOnPage do
  begin
    TheText := FileLines^.At(Line);
    if TheText <> nil then
      TextOut(DC,xOffset,lney+(Line-FirstOnPage)*TextHeight,TheText,StrLen(TheText));
  end;
  if ftrexists then
   begin
    if strlen(hlne[4])>0 then TextOut(DC,xOffset,ftry,hlne[4],strlen(hlne[4]));
    if strlen(hlne[5])>0 then
     begin
      SetTextAlign(DC,TA_Center or TA_Top);
      TextOut(DC,(size.x-xOffset) div 2,ftry,hlne[5],strlen(hlne[5]));
     end;
    if strlen(hlne[6])>0 then
     begin
      SetTextAlign(DC,TA_Right or TA_Top);
      TextOut(DC,size.x,ftry,hlne[6],strlen(hlne[6]));
     end;
    SetTextAlign(DC,TA_Left or TA_Top);
   end;
  SelectObject(DC,oFont);
end;

var
  TextApp: TTextApp;

begin
  TextApp.Init('TextPrn');
  TextApp.Run;
  TextApp.Done;
end.
